<template>
	<div class="ui-input" :class="[inputIsFocused ? 'ui-input__focused' : '', error ? 'ui-input__error' : '']">
		<div class="ui-input__wrapper">
			<div class="ui-input__prefix" v-if="$slots.prefix">
				<slot name="prefix"/>
			</div>
			<div class="ui-input__content" :class="classList">
				<input ref="input"
				       :for="id"
				       :v-model="value"
				       :type="dynamicType"
				       class="ui-input__input"
				       v-mask="mask"
				       :value="type !== 'password' && !!uppercase ? value.toUpperCase() : value"
				       :filled="!!value"
				       @input="$emit('input', $event.target.value)"
				       @focus="inputIsFocused = true"
					   :autocomplite="autocomplite ? '' : 'off'"
				       @blur="inputIsFocused = false;setSuggestion();"/>
				<label :for="id"
				       class="ui-input__label"
				       @click="$refs.input.focus()">{{ label }}</label>
			</div>
			<div class="ui-input__suffix" v-if="$slots.suffix">
				<slot name="suffix"/>
			</div>
		</div>
		<transition name="fade">
			<div v-if="error" class="ui-input__error-message">
				{{ error }}
			</div>
		</transition>
	</div>
</template>

<script>
	let cvvWatch;

	export default {
		name: "ui-input",
		props: {
			id: {
				required: false,
				default: '',
				type: String
			},
			value: {
				required: false,
			},
			label: {
				required: false,
				default: '',
				type: String,
			},
			error: {
				required: false,
				default: '',
				type: String,
			},
			suggestions: {
				required: false,
				default: () => [],
				type: Array,
			},
			suggestionHandler: {
				required: false,
				type: Function,
			},
			type: {
				required: false,
				default: 'text',
				type: String
			},
			mask: {
				required: false,
				default: '',
				type: String
			},
			uppercase: {
				required: false,
				default: false,
				type: Boolean
			},
			prefix: {
				type: Boolean
			},
			suffix: {
				type: Boolean
			},
			autocomplite: {
				type: Boolean,
				default: false,
			}
		},
		data() {
			return {
				inputIsFocused: false,
				suggestionIndex: -1,
			};
		},
		computed: {
			classList() {
				let list = [];
				if (this.$slots.suffix && this.$slots.prefix) {
					list.push('ui-input__with-prefix-suffix');
				} else if (this.$slots.prefix || this.prefix) {
					list.push('ui-input__with-prefix');
				} else if (this.$slots.suffix || this.suffix) {
					list.push('ui-input__with-suffix');
				}
				return list
			},

			dynamicType () {
				if(this.type === 'cvv') {
					return this.getDynamicCvvType();
				}

				return this.type;
			}
		},
		watch: {
			input(v) {
				this.$emit('input', v);
			},

			suggestions(s) {
				if (s.length) {
					document.addEventListener('keyup', this.selectSuggestionByArrow);
				} else {
					document.removeEventListener('keyup', this.selectSuggestionByArrow);
				}
			},
		},

		created () {
			if (this.type === 'cvv') {
				this.initCvv();
			}
		},

		beforeDestroy () {
			console.log('cvvWatch', cvvWatch);
			if(cvvWatch) {
				// cvvWatch.unwatch();
			}
		},

		methods: {
			setSuggestion(suggestion, index) {
				this.suggestionIndex = index;
				if (typeof this.suggestionHandler === 'function') {
					try {
						this.suggestionHandler(suggestion);
					} catch (e) {
						console.warn('ui-input::suggestionHandler error');
						console.warn(e);
					}
				}
			},

			selectSuggestionByArrow(e) {
				const length = this.suggestions.length;
				switch (e.keyCode) {
					case 38:// up
						this.suggestionIndex ? this.suggestionIndex-- : this.suggestionIndex = length - 1;
						e.preventDefault();
						break;
					case 40:// down
						this.suggestionIndex === length - 1 ? this.suggestionIndex = 0 : this.suggestionIndex++;
						e.preventDefault();
						break;
					case 13:// enter
						this.setSuggestion(this.suggestions[this.suggestionIndex], this.suggestionIndex);
						e.preventDefault();
						break;
				}
			},

			getDynamicCvvType () {
				return 'password';
			},

			initCvv () {
				// cvvWatch = this.$watch('input', this.cvvWatchHandler);
			},

			cvvWatchHandler () {

			}
		},
	}
</script>

<style scoped lang="scss">
	@import './../../../static/css/variables/main';
	@import './../../../static/css/mixins/main';

	.ui-input {
		@include size(100%, 55px);
		border: 1px solid $border;
		background: #f8f8f8;
		border-radius: 5px;
		@include position(relative);

		&__focused {
			border: 1px solid #ffdd35;
		}

		&__wrapper {
			@include size(100%, 100%);
			@include flex(flex, row, wrap);
		}

		&__content {
			@include size(100%, 100%);
			@include flex(flex, row, wrap);
		}

		&__input {
			@include size(100%, 100%);
			margin: 0;
			padding: 12px 20px 0;
			border: none;
			color: #323c47;
			font-weight: 500;

			&:focus {
				border: none;

				& + .ui-input__label {
					@include position(null, $c: (top: 5px, left: 20px));
					font-size: 11px;
					color: #b7c6d0;
				}
			}

			&[filled="true"] {
				& + .ui-input__label {
					@include position(null, $c: (top: 5px, left: 20px));
					font-size: 11px;
					color: #b7c6d0;
				}
			}
		}

		&__with-prefix {
			@include size(calc(100% - 55px));

			.ui-input__input {
				border-left: 1px solid $border;
				border-right: none;
				border-radius: 0 5px 5px 0;
			}

			.ui-input__label {
				@include size(calc(100% - 55px - 40px));
				@include position(null, $c: (left: 75px !important));
			}
		}

		&__with-suffix {
			@include size(calc(100% - 55px));

			.ui-input__input {
				border-left: none;
				border-right: 1px solid $border;
				border-radius: 5px 0 0 5px;
			}

			.ui-input__label {
				@include size(calc(100% - 55px - 40px));
				@include position(null, $c: (left: 20px !important));
			}
		}

		&__with-prefix-suffix {
			@include size(calc(100% - 110px));

			.ui-input__input {
				border-left: 1px solid $border;
				border-right: 1px solid $border;
				border-radius: 0;
			}

			.ui-input__label {
				@include size(calc(100% - 55px - 40px));
				@include position(null, $c: (left: 75px !important));
			}
		}

		&__label {
			@include size(calc(100% - 40px));
			@include position(absolute, $c: (top: 16px, left: 20px));
			font-size: 15px;
			transition: all .3s ease;
			white-space: nowrap;
			text-overflow: ellipsis;
			overflow: hidden;
		}

		.prefix-suffix {
			@include size(55px);
			@include flex(flex, row, nowrap);
			align-items: center;
			justify-content: center;
		}

		&__prefix {
			@extend .prefix-suffix;
		}

		&__suffix {
			@extend .prefix-suffix;
		}

		&__error {
			border: 1px solid $red;
			.ui-input__input {
				color: $red;
			}
		}

		&__error-message {
			margin-top: 5px;
			@include font(13px, 400, 20px);
			color: $red
		}
	}
</style>
